﻿/* ===========================
STF_ Actions.as
Copyright ScreenTime Media
Brian Hutichins

STF is an object that extends  the ScreenTime for Flash screen saver and your screen saver swf.  
To utilize the functions below, #inlcude this file in your main screen saver fla.
=============================

STF.checkNetConnection (returnValue)
returnValue - name of the variable to store result (notConnected=0, connected=1).

STF.debugTrace (traceMessage)
traceMessage - text string. 

STF.debugTraceMessages (turnDebugTraceOn)
turnDebugTraceOn - true or false.

STF.downloadFile (fileName, URL, returnValue)
fileName - Name of local file where the downloaded file should be saved. File will be placed next to saver.swf.
URL - URL of the remote file to be downloaded.
returnValue - name of the variable to store result (downloadSuccessful=0, downloadSuccessful=1).

STF.executeApplication (application, parameters, show)
application - Application file name.
parameters - Command line parameters.
show - one of the following string values:
    * "HIDE" Hides the application window and activates another window.
    * "MAXIMIZE" Maximizes the application window.
    * "MINIMIZE" Minimizes the application window and activates the next top-level window in the Z-order.
    * "RESTORE" Activates and displays the application window in its original size and position.
    * "SHOW" Activates the application window and displays it in its current size and position.
    * "SHOWMAXIMIZED" Activates the application window and displays it as a maximized window.
    * "SHOWMINIMIZED" Activates the application window and displays it as a minimized window.
    * "SHOWMINNOACTIVE" Displays the application window as a minimized window. The active window remains active.
    * "SHOWNA" Displays the window in its current state. The active window remains active.
    * "SHOWNOACTIVATE" Displays a window in its most recent size and position. The active window remains active.
    * "SHOWNORMAL" Activates and displays a window. If the window is minimized or maximized, Windows restores it to its original size and position. An application should specify this flag when displaying the window for the first time.

STF.forceUserLogOff () **
Description: Quit screen saver, log off user, and show user login screen.

STF.getSystemDir (returnValue) **
STF.getWindowsDir (returnValue) **
STF.launchAndQuit (URL) **
Description: Launch a browser and quit saver on browser close or minimize.

STF.setActiveWallpaper (fileName, tileOrCenterOrStretch, returnValue)
fileName - relative path of local file where the downloaded file should be saved. Path is relative to the saver.swf -- a/b/temp.jpg.
tileOrCenterOrStretch - display image "tile" or "center" or "stretch". Mac always sets image to stretch.
returnValue - name of the variable to store result (successful=0, failed=1).

STF.quitSlow() **
Description: quits after 2 second delay and after killing all sublaunched browser windows.

STF.quit ()

STF.setDesktopBackgroundColor (red, green, blue)
red = 0 to 255
green = 0 to 255
blue = 0 to 255 

**Windows Only

=================================*/

if (_global.STF == null) {
	_global.STF = new Object();
	_global.STF.version = "1.0.0";
	_global.traceOn = true;
	_global.STF.browserOpened = false;
	var system_str = System.capabilities.os.toLowerCase();
	if (system_str.indexOf("windows")>=0) {
		_global.STF.platform_str = "Windows";
	} else if (system_str.indexOf("mac")>=0) {
		_global.STF.platform_str = "Mac";
	} else {
		_global.STF.platform_str = "";
	}
	trace("STF loaded");
}

_global.STF.sendAction = function(command_str, parameters_str) {
	this.debugTrace("command_str:"+command_str);
	this.debugTrace("parameters_str:"+parameters_str); 
	this.debugTrace("this.platform_str:"+this.platform_str);
	if (this.platform_str == "Windows") {
		this.debugTrace("fscommand (" + "\"" + command_str + "\"" + ", "  + "\""+parameters_str+"\"" + ");");
		fscommand(command_str, parameters_str);
	} else if (this.platform_str == "Mac") {
		var url_str = "ST://ST_" + command_str + parameters_str;
		this.debugTrace("loadVariables (" + "\"" + url_str + "\"" + ", "  +"_root" +  ");");
		loadVariables(url_str, _root);
	} else {
		var tempMessage = "ST commands: This functionality";
		tempMessage += " is currently implemented in Windows and MacOS only.";
		tempMessage += newline+" -> "+command_str+" "+parameters_str;
		this.debugTrace(tempMessage);
	}
};

_global.STF.debugTrace = function(traceMessage) {
	if (this.traceOn) {
		trace(traceMessage);
	}
};

_global.STF.debugTraceMessages = function(turnDebugTraceOn) {
	if (turnDebugTraceOn) {
		_global.STF.traceOn = true;
	} else {
		_global.STF.traceOn = false;
	}
};

STF.debugTraceMessages(true);

_global.STF.downloadFile = function(fileName, URL, returnValue) {
	var param_str = "?fileName=" + fileName + "&URL=" + URL + "&returnValue=" + returnValue;
	STF.sendAction("downloadFile", param_str);
};

_global.STF.saveVariable = function(variableName, value) {
	var param_str = "?variableName=" + varName + "&value=" + value;
	this.sendAction("saveVariable", param_str);
};

_global.STF.checkNetConnection = function(returnValue) {
	var param_str = "?returnValue=" + returnValue;
	this.sendAction("checkNetConnection", param_str);
};

_global.STF.quit = function() {
	this.sendAction("quit");
};

_global.STF.quitFast = function() {
	// quit without wainting for browser to close
	this.sendAction("quitFast");
};

_global.STF.forceUserLogOff = function() {
	this.sendAction("forceUserLogOff");
};

_global.STF.launchAndQuit = function(URL) {
	param_str = "?URL=" + URL ;
  
	this.sendAction("launchAndQuit", param_str);
};

_global.STF.setDesktopBackgroundColor = function(red, green, blue) {
	var param_str = "?red=" + red + "&green=" + green + "&blue=" + blue;   
	
	this.debugTrace("setDesktopBackgroundColor -- param_str: " + param_str);
	this.sendAction("setDesktopBackgroundColor", param_str);
};

_global.STF.executeApplication = function(application, parameters, show) {
	var param_str = "?application=" + application + "&parameters=" + parameters + "&show=" + show;
	this.debugTrace("xxxxxxxxxxxxxxxxxxexecuteApplication -- param_str: " + param_str);
	this.sendAction("executeApplication", param_str);
};


_global.STF.setActiveWallpaper = function(fileName, tileOrCenterOrStretch, returnValue) {
	var displayMethod, param_str;
	
	displayMethod = tileOrCenterOrStretch.toUpperCase();
	this.debugTrace(displayMethod);
	
	switch (displayMethod) {
  		case "TILE":
		case "CENTER":
		case "STRETCH":
    		//displayMethod = tileOrCenterOrStretch;
    		break;
		default:
			this.debugTrace("taking default");
    		displayMethod = "CENTER";
    		break;		
	}
	param_str = "?fileName=" + fileName + "&tileOrCenterOrStretch=" + displayMethod + "&returnValue=" + returnValue;
	this.sendAction("setActiveWallpaper", param_str );
};

_global.STF.makeDownloadedWallpaperActive = function(fileName, tileOrCenterOrStretch, returnValue) {
	var displayMethod, param_str;
	
	displayMethod = tileOrCenterOrStretch.toUpperCase();
	this.debugTrace(displayMethod);
	
	switch (displayMethod) {
  		case "TILE":
		case "CENTER":
		case "STRETCH":
    		//displayMethod = tileOrCenterOrStretch;
    		break;
		default:
			this.debugTrace("taking default");
    		displayMethod = "CENTER";
    		break;		
	}
	param_str = "?fileName=" + fileName + "&tileOrCenterOrStretch=" + displayMethod + "&returnValue=" + returnValue;
	this.sendAction("makeDownloadedWallpaperActive", param_str );
};

_global.STF.getWindowsDir = function(returnValue) {
	var param_str = "?returnValue=" + returnValue;

	this.sendAction("getWindowsDir", param_str);
};

_global.STF.getSystemDir = function(returnValue) {
	var param_str  = "?returnValue=" + returnValue;
	
	this.sendAction("getSystemDir", param_str);
};
